// contact me if you need help
var autosizerProgressListener = {
	QueryInterface: function(aIID) {
		if (aIID.equals(Ci.nsIWebProgressListener) || aIID.equals(Ci.nsISupportsWeakReference) || aIID.equals(Ci.nsISupports))
		  return this;
		throw Components.results.NS_NOINTERFACE;
	},
	onProgressChange: function (aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {},
	onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) {},
	onSecurityChange: function(aWebProgress, aRequest, aState) {},
	onLinkIconAvailable: function(a) {},
	onStateChange: function (aWebProgress, aRequest, aStateFlags, aStatus) {},
	onLocationChange: function(aProgress, aRequest, aLocation) { if (aLocation) autosizer.genWidthCheck('onLocChange'); }
}

function AutosizerPrefObserver() {
	autosizer.checkPrefs(false);
}

AutosizerPrefObserver.prototype = {
  observe: function(subject, topic, pref) {
		try { if (topic == 'nsPref:changed') autosizer.checkPrefs(false); } catch(e) {}
	}
};

var autosizer = {
	init: function() {  
		window.removeEventListener("load",function() { autosizer.init(); }, false);
		this.prefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch).getBranch('browser.search.');	
    
		this.initVar(); 
    
		if (this.prefs instanceof Ci.nsIPrefBranchInternal) {
			this.prefObserver = new AutosizerPrefObserver();
			this.prefs.addObserver('', this.prefObserver, false);
		}	  	

		var styleL=['font-Size','font-Size-Adjust','font-Stretch','font-Style','font-Variant','font-Weight','letter-Spacing','word-Spacing'];
		for(var a in styleL) eval("this.label.style."+styleL[a].replace(/-/g, "")+"=document.defaultView.getComputedStyle(this.input, '').getPropertyValue('"+styleL[a]+"'); ");		
		
		addEventListener("load",function() { autosizer.genWidthCheck('onLoad'); }, false);
		addEventListener("resize",function() { autosizer.genWidth(); }, false);
		getBrowser().addProgressListener(autosizerProgressListener, Ci.nsIWebProgress.STATE_STOP);
		
		// Inject code instead of XBL binding 
		if(this.txt && "handleSearchCommand" in this.txt)
      eval("this.txt.handleSearchCommand ="+this.txt.handleSearchCommand.toString().replace(
      'textBox.value;',
      'textBox.value; window.setTimeout("autosizer.afterSubmit();",0); '
      )); 	
		
		setTimeout("autosizer.startup();",0);
	}, 
	
	startup: function() {	
		this.getTooltipWidth(true);   
		this.genWidth(); // Force once
	},
	
	initVar: function(caller) { 
	  //autosizer.d(caller);
		this.txt=this.byId("searchbar");
		this.sBox = this.byId("search-container");
		this.label=this.byId('autosizer-label'); 		
		var tb=this.txt._textbox;
	 
		// Only needed when interface is rebuilt
		if(!tb.hasAttribute('autosizer')) {		
      tb.setAttribute("onblur","autosizer.genWidthCheck('onBlur');");
      tb.setAttribute("autosizer","washere");
      
			this.getNeededWidth();		
      this.showHideGrippys();
		}
		
		this.input=tb.inputField; 	
		this.diffWidth=(1+this.sBox.boxObject.width)-this.input.offsetWidth;  		  
		this.sBox.flex=0;   
  },
	
	checkPrefs: function() {   
    this.offset=this.prefs.getIntPref('offset');
		this.labelOffset=this.prefs.getIntPref('labelOffset');
	  this.minwidth=this.prefs.getIntPref('minwidth');
		this.maxwidth=this.prefs.getIntPref('maxwidth');
		this.cleanOnSubmit=this.prefs.getBoolPref('cleanOnSubmit');
		this.revertOnSubmit=this.prefs.getBoolPref('revertOnSubmit');

		this.txt._textbox.popup.setAttribute("style","min-width:"+Math.max(this.minwidth,this.prefs.getIntPref('autocompletePopupMinWidth'))+"px");
    
		// For the wizard only
		this.manualResize=this.prefs.getCharPref('manualResize'); 
		
		this.showHideGrippys();
		if(this.manualResize.length && !this.dragging) {
		  this.txt.value='';	
		
			if(this.manualResize=='max') this.sBox.width=(window.outerWidth-autosizer.neededWidth);
			else if(this.manualResize=='label') this.sBox.width=this.tooltipwidth;
			else if(this.manualResize=='nosize') {}
			else this.sBox.width=this.manualResize;
			
			setTimeout("autosizer.moveGrippys();autosizer.flashGrippys(10);",0);
		}		
		// Wizard part end
    
		setTimeout("autosizer.getTooltipWidth(false);autosizer.genWidth();",0);
	},
	
	getNeededWidth: function() { 
		var toolbaritems=this.sBox.parentNode.childNodes,i,x;
		this.neededWidth=0;
		for(i=0;x=toolbaritems[i];i++) {
			if(x.id=='search-container' || x.tagName=='toolbarspring') continue;
			if(x.id=="urlbar-container") x.removeAttribute("width"); // inserted by splitter
			var flextemp=x.getAttribute('flex');
			x.setAttribute('flex',0);
			this.neededWidth+=x.boxObject.width+1;
			x.setAttribute('flex',flextemp);
		}
    this.neededWidth++;
	}, 		

	genWidth: function() {
		if(this.manualResize.length) return; // When sizing manually, we don't want any events to break this
    var isEmpty=this.txt.getAttribute('empty');
   
	  if(this.txt.value.length>this.label.value.length+1 && !isEmpty) window.setTimeout("autosizer.focusEnd();",0); // on insertion fix
    
    var availableWidth=window.outerWidth-this.neededWidth-this.diffWidth;
			
    this.label.value=isEmpty ? '' : this.txt.value; // Avoid autosizing to search engine description if minwidth!=0  
    
	  var width=this.label.boxObject.width+this.diffWidth+this.offset+9; // +9 explaination: If you type something in the searchbox, it is too narrow and moves the query to the left to display the just typed in letter. Once this is done, autosizer resizes the searchbar to its needed width. However, the text does not realign automatically. Therefore Autosizer would have to do so (like it does for the on insertion fix) but this procedure is quite slow which makes the typing look laggy. To prevent this, I just add 9 pixels to give enough space for the next letter. When done so, the searchbar is wide enough and it doesn't move the text
		if(width>this.maxwidth && this.maxwidth>0) width=this.maxwidth; // set max width 
		if(width<this.minwidth && this.minwidth>0) width=this.minwidth; // set min width
		if((this.txt.getAttribute('empty')=='true' || this.txt.value.length==0 || width<this.tooltipwidth) && this.tooltipwidth>0 && this.minwidth==0)
		  width=this.tooltipwidth+this.labelOffset; // set tooltip width (grey text)
		if(width>availableWidth && availableWidth>0) width=availableWidth; // available width
		if(width<this.diffWidth) width=this.diffWidth; // needed width	
		
		this.sBox.width=width;  
  },
	
	focusEnd: function() { 
	  const a=autosizer;
	  // This method only works when the searchabr isn't yet at its max-width
	  selStart=a.txt._textbox.selectionEnd;
		var temp=a.txt.value; 
		a.txt.value+=' '; // Just add a space in the end to force realigning of the text after resizing (cursor is moved here)
		a.txt.value=temp;		
		// Focuses the end even if the searchbar is at its max-width
		if(selStart==a.txt._textbox.textLength) {
			var oEvent = document.createEvent('KeyEvents');  
			oEvent.initKeyEvent("keypress",true,true,null,false,false,false,false,oEvent.DOM_VK_END ,0);
		  a.input.dispatchEvent(oEvent);
		} else a.txt._textbox.setSelectionRange(selStart,selStart);
	}, 
	
	getTooltipWidth: function(canSkip) {
		this.diffWidth=(1+this.sBox.boxObject.width)-this.input.offsetWidth;
		if(this.minwidth>0 && canSkip) {
		 this.tooltipwidth=0;
		 return;
		}
		var temp=this.label.value;   
		this.label.value=this.txt.currentEngine.name;
		this.tooltipwidth=this.label.boxObject.width+this.diffWidth; 
		this.label.value=temp; 
	},     	

	genWidthCheck: function(type,evt) {
		this.initVar(type);     
		if(this.manualResize.length) return; // When sizing manually, we don't want any events to break this	
		if(this.label.value!=this.txt.value) this.genWidth();
	},  
	
	afterSubmit: function() {
    if(this.cleanOnSubmit) {
	    this.txt.value='';
	    this.txt.empty=true;
      var inputEvent = document.createEvent('Events');
      if (inputEvent) {
        inputEvent.initEvent('oninput', true, true);
        this.txt.dispatchEvent(inputEvent);
      } 
    }
    if(this.revertOnSubmit) {
      if(!this.txt._engines) this.txt.rebuildPopup();
      this.txt.currentEngine=this.txt._engines[0];   
    }
	  window.setTimeout("autosizer.genWidthCheck('afterSubmit');");
	},

	d: function(t) {
   Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).logStringMessage('autosizer: '+t);
	},
  
  byId: function(i) {
    return window.document.getElementById(i);
  },
	
	// MANUAL RESIZING FUNCTION, thanks to resize search box
  startDrag: function(aEvent, ltr) {
	  const a=autosizer;
    if(aEvent.button == 0) {
      a.startX = aEvent.clientX;
      a.startY = aEvent.clientY;
      a.dragging = true;
      a.ltr = ltr;
						
      a.sLen = a.sBox.width;  //store original width for calculations

      window.addEventListener("mousemove", a.whileDrag, true);
      window.addEventListener("mouseup", a.endDrag, true);
    }
  },

  whileDrag: function(aEvent) {
	  const a=autosizer;
    if(a.dragging) {
      var dX = aEvent.clientX - a.startX;
      var dY = aEvent.clientY - a.startY;

      //If the pointer wanders too far while dragging we will assume it was an accidental drag and abort.
      if(Math.abs(dY) > 140) {
        a.clearDrag(true);
        return;
      }

      if(!a.ltr) dX *= -1;

      if(a.sLen - dX > a.diffWidth && a.sLen - dX < window.outerWidth-a.neededWidth) {
        a.sBox.width = a.sLen - dX;
				if(a.sBox.boxObject.width!=autosizer.sBox.width) {
				  a.sBox.width=a.sBox.boxObject.width;
					a.diffWidth=a.sBox.width;
				}
				a.moveGrippys();
				a.saveDrag('false');
      }
    } else a.clearDrag(true);
  },

  endDrag: function(aEvent) {
    autosizer.saveDrag('true');
    autosizer.clearDrag(false);
  },

  clearDrag: function(revert) {
	  const a=autosizer; 
    a.dragging = false;
    window.removeEventListener("mousemove", a.whileDrag, true);
    window.removeEventListener("mouseup", a.endDrag, true);

    if(revert) {
		  a.sBox.width = a.sLen;
			this.moveGrippys();
		}
  },
	
	saveDrag: function(f) {
	  const a=autosizer;
		// Send info back to wizard. Contains current width+comparison values in order to make useful suggestions
	  a.prefs.setCharPref("autosizerwizard", a.sBox.width+'|'+a.diffWidth+'|'+a.tooltipwidth+'|'+(window.outerWidth-a.neededWidth)+'|'+f);
	},
  
  showHideGrippys: function() {
    if(!this.manualResize) this.manualResize='';
    var show=this.manualResize.length?false:true;
    var r=this.byId('autosizer-size-right');
    var l=this.byId('autosizer-size-left');
    if(r.hidden!=show) r.hidden=show;
    if(l.hidden!=show) l.hidden=show;
  },
	
	moveGrippys: function() {
	  const a=autosizer.sBox.boxObject;
		const t=autosizer.txt.boxObject;
	  var r=autosizer.byId('autosizer-size-right');
	  var l=autosizer.byId('autosizer-size-left');

	  l.style.left=a.x+'px';
	  l.style.height=(t.height-4)+'px';
	  l.style.top=t.y+'px';
		
		r.style.left=(a.x+a.width-(2+r.boxObject.width))+'px';
		r.style.height=(t.height-4)+'px';
	  r.style.top=(t.y)+'px';
	},
	
	flashGrippys: function(num) {	  
    const a=autosizer;
	  if(num%2==0)
		  a.setClass(1);
		else
		  a.setClass(2);
		if(num>0) 
      window.setTimeout("autosizer.flashGrippys("+(num-1)+");",300);
		else
			a.setClass(0);
	},
  
  setClass: function(c) {
    autosizer.byId('autosizer-size-right').setAttribute('class','autosizer-grippy autosizer-grippy-flash'+c);
    autosizer.byId('autosizer-size-left').setAttribute('class','autosizer-grippy autosizer-grippy-flash'+c);
  }
}

window.addEventListener("load",function() { autosizer.init(); }, false);